## ros-crystal-depth-image-proc 2.0.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(depth_image_proc)

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

find_package(ament_cmake REQUIRED)
find_package(rclcpp REQUIRED)
find_package(cv_bridge REQUIRED)
find_package(tf2_eigen REQUIRED)
find_package(image_geometry REQUIRED)
find_package(image_transport REQUIRED)
find_package(message_filters REQUIRED)
find_package(class_loader REQUIRED)
find_package(sensor_msgs REQUIRED)
find_package(stereo_msgs REQUIRED)
find_package(tf2 REQUIRED)
find_package(tf2_ros REQUIRED)

find_package(Eigen3 QUIET)
if(NOT EIGEN3_FOUND)
  find_package(Eigen REQUIRED)
  set(EIGEN3_INCLUDE_DIRS ${EIGEN_INCLUDE_DIRS})
endif()
find_package(OpenCV REQUIRED)
include_directories(include ${BOOST_INCLUDE_DIRS} ${rclcpp_INCLUDE_DIRS} ${EIGEN3_INCLUDE_DIRS})

add_library(${PROJECT_NAME} SHARED
  src/nodelets/convert_metric.cpp
  src/nodelets/crop_foremost.cpp
  src/nodelets/disparity.cpp
  src/nodelets/point_cloud_xyz.cpp
  src/nodelets/point_cloud_xyzrgb.cpp
  src/nodelets/point_cloud_xyzi.cpp
  src/nodelets/point_cloud_xyz_radial.cpp
  src/nodelets/point_cloud_xyzi_radial.cpp
  src/nodelets/register.cpp
)
ament_target_dependencies(${PROJECT_NAME}
  "image_transport"
  "image_geometry"
  "cv_bridge"
  "class_loader"
  "message_filters"
  "rclcpp"
  "tf2_ros"
  "tf2"
  "tf2_eigen"
  "stereo_msgs"
  "sensor_msgs"
)

rclcpp_register_node_plugins(${PROJECT_NAME} "${PROJECT_NAME}::ConvertMetricNode")
rclcpp_register_node_plugins(${PROJECT_NAME} "${PROJECT_NAME}::CropForemostNode")
rclcpp_register_node_plugins(${PROJECT_NAME} "${PROJECT_NAME}::DisparityNode")
rclcpp_register_node_plugins(${PROJECT_NAME} "${PROJECT_NAME}::PointCloudXyzNode")
rclcpp_register_node_plugins(${PROJECT_NAME} "${PROJECT_NAME}::PointCloudXyzRadialNode")
rclcpp_register_node_plugins(${PROJECT_NAME} "${PROJECT_NAME}::PointCloudXyziNode")
rclcpp_register_node_plugins(${PROJECT_NAME} "${PROJECT_NAME}::PointCloudXyziRadialNode")
rclcpp_register_node_plugins(${PROJECT_NAME} "${PROJECT_NAME}::PointCloudXyzrgbNode")
rclcpp_register_node_plugins(${PROJECT_NAME} "${PROJECT_NAME}::RegisterNode")

target_link_libraries(${PROJECT_NAME} ${ament_LIBRARIES} ${OpenCV_LIBRARIES})

install(DIRECTORY include/${PROJECT_NAME}/
    DESTINATION include/${PROJECT_NAME}
    FILES_MATCHING PATTERN "*.h")

install(TARGETS ${PROJECT_NAME}
        DESTINATION lib
)
install(DIRECTORY examples/launch
  DESTINATION share/${PROJECT_NAME}/
)

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  ament_lint_auto_find_test_dependencies()
endif()

ament_package()

=== debian/changelog ===
ros-crystal-depth-image-proc (2.0.0-0bionic) bionic; urgency=high

  * enable rclcpp_register_node_plugins (#368 <https://github.com/ros-perception/image_pipeline/issues/368>)
    this may be remarked while code debugging, should be enabled to build node plugin file
    and added points remap in point_cloud_xyzrgb.launch.py
  * Port depth image proc on ROS2 (#362 <https://github.com/ros-perception/image_pipeline/issues/362>)
    * Port depth_image_proc on ROS2
    * Port depth_image_proc of image_pipeline on ROS2
    * rename Nodelets as Node
    * add launch examples, such as "ros2 launch depth_image_proc point_cloud_xyzi.launch.py"
    * verified point_cloud_xyzrgb, point_cloud_xyz, convert_metric based on Realsense camera(https://github.com/intel/ros2_intel_realsense).
    Signed-off-by: Chris Ye <mailto:chris.ye@intel.com>
    * add ament_lint_auto test and adjust code style
    Signed-off-by: Chris Ye <mailto:chris.ye@intel.com>
    * update test example for depth_image_proc
    - rename raw topic as image_transport fixed the issue (https://github.com/ros-perception/image_common/issues/96)
    - update test example of point_cloud_xyzrgb.launch
    Signed-off-by: Chris Ye <mailto:chris.ye@intel.com>
    * remove unused dependence in cmakelist
    * remove boost which is unused on ROS2
    * remove cv_bridge version check logic as setted in find_package
    * update maintainer in package.xml
    Signed-off-by: Chris Ye <mailto:chris.ye@intel.com>
    * added all example launchers for demo test
    pass test:
    ros2 launch depth_image_proc point_cloud_xyzrgb.launch.py
    ros2 launch depth_image_proc point_cloud_xyz.launch.py
    ros2 launch depth_image_proc convert_metric.launch.py
    ros2 launch depth_image_proc crop_foremost.launch.py
    ros2 launch depth_image_proc point_cloud_xyz_radial.launch.py
    ros2 launch depth_image_proc disparity.launch.py
    ros2 launch depth_image_proc register.launch.py
    ros2 launch depth_image_proc point_cloud_xyzi.launch.py
    ros2 launch depth_image_proc point_cloud_xyzi_radial.launch.py
    Signed-off-by: Chris Ye <mailto:chris.ye@intel.com>
    * @wip update to use raw pointers.
    * continue to update to use raw pointer
    Signed-off-by: Chris Ye <mailto:chris.ye@intel.com>
  * Initial ROS2 commit.
  * Contributors: Chris Ye, Michael Carroll

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Sun, 09 Dec 2018 06:00:00 -0000

ros-crystal-depth-image-proc (1.12.23-0bionic) bionic; urgency=high



 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Thu, 10 May 2018 05:00:00 -0000

ros-crystal-depth-image-proc (1.12.22-0bionic) bionic; urgency=high



 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Fri, 08 Dec 2017 06:00:00 -0000

ros-crystal-depth-image-proc (1.12.21-0bionic) bionic; urgency=high

  * Fix C++11 compilation
    This fixes #292 <https://github.com/ros-perception/image_pipeline/issues/292> and #291 <https://github.com/ros-perception/image_pipeline/issues/291>
  * Contributors: Vincent Rabaud

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Sun, 05 Nov 2017 05:00:00 -0000

ros-crystal-depth-image-proc (1.12.20-0bionic) bionic; urgency=high

  * Fix CMake warnings about Eigen.
  * Convert depth image metric from [m] to [mm]
  * address gcc6 build error
    With gcc6, compiling fails with stdlib.h: No such file or directory,
    as including '-isystem /usr/include' breaks with gcc6, cf.,
    https://gcc.gnu.org/bugzilla/show_bug.cgi?id=70129.
    This commit addresses this issue for this package in the same way
    it was addressed in various other ROS packages. A list of related
    commits and pull requests is at:
    https://github.com/ros/rosdistro/issues/12783
    Signed-off-by: Lukas Bulwahn <mailto:lukas.bulwahn@oss.bmw-carit.de>
  * Contributors: Kentaro Wada, Lukas Bulwahn, Vincent Rabaud

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Sun, 30 Apr 2017 05:00:00 -0000

ros-crystal-depth-image-proc (1.12.19-0bionic) bionic; urgency=high



 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Sun, 24 Jul 2016 05:00:00 -0000

ros-crystal-depth-image-proc (1.12.18-0bionic) bionic; urgency=high



 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Tue, 12 Jul 2016 05:00:00 -0000

ros-crystal-depth-image-proc (1.12.17-0bionic) bionic; urgency=high



 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Mon, 11 Jul 2016 05:00:00 -0000

ros-crystal-depth-image-proc (1.12.16-0bionic) bionic; urgency=high

  * check number of channels before the process
  * search minimum value with OpenCV
  * Use OpenCV to be faster
  * Add a feature for a depth image to crop foremost image
  * Contributors: Kenta Yonekura

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Sat, 19 Mar 2016 05:00:00 -0000

ros-crystal-depth-image-proc (1.12.15-0bionic) bionic; urgency=high

  * Add option for exact time sync for point_cloud_xyzrgb
  * simplify OpenCV3 conversion
  * Contributors: Kentaro Wada, Vincent Rabaud

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Sun, 17 Jan 2016 06:00:00 -0000

ros-crystal-depth-image-proc (1.12.14-0bionic) bionic; urgency=high



 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Wed, 22 Jul 2015 05:00:00 -0000

ros-crystal-depth-image-proc (1.12.13-0bionic) bionic; urgency=high

  * Add radial point cloud processors
  * Contributors: Hunter Laux

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Mon, 06 Apr 2015 05:00:00 -0000

ros-crystal-depth-image-proc (1.12.12-0bionic) bionic; urgency=high

  * adds range_max
  * exports depth_conversions
    with convert for xyz PC only
  * exports DepthTraits
  * Contributors: enriquefernandez

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Wed, 31 Dec 2014 06:00:00 -0000

ros-crystal-depth-image-proc (1.12.11-0bionic) bionic; urgency=high



 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Sun, 26 Oct 2014 05:00:00 -0000

ros-crystal-depth-image-proc (1.12.10-0bionic) bionic; urgency=high



 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Sun, 28 Sep 2014 05:00:00 -0000



=== debian/control ===
Source: ros-crystal-depth-image-proc
Section: misc
Priority: extra
Maintainer: Vincent Rabaud <vincent.rabaud@gmail.com>
Build-Depends: debhelper (>= 9.0.0), ros-crystal-ament-cmake, ros-crystal-ament-cmake-gtest, ros-crystal-ament-lint-auto, ros-crystal-ament-lint-common, ros-crystal-class-loader, ros-crystal-cv-bridge, ros-crystal-image-geometry, ros-crystal-image-transport, ros-crystal-message-filters, ros-crystal-sensor-msgs, ros-crystal-stereo-msgs, ros-crystal-tf2, ros-crystal-tf2-eigen, ros-crystal-tf2-ros, ros-crystal-ros-workspace
Homepage: http://ros.org/wiki/depth_image_proc
Standards-Version: 3.9.2

Package: ros-crystal-depth-image-proc
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-crystal-cv-bridge, ros-crystal-image-geometry, ros-crystal-image-transport, ros-crystal-tf2, ros-crystal-tf2-eigen, ros-crystal-tf2-ros, ros-crystal-ros-workspace
Description: Contains nodelets for processing depth images such as those produced by OpenNI camera.
 Functions include creating disparity images and point clouds, as well as registering (reprojecting) a depth image into another camera frame.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/crystal/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/crystal/setup.sh" ]; then . "/opt/ros/crystal/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/crystal" \
		-DAMENT_PREFIX_PATH="/opt/ros/crystal"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/crystal/setup.sh" ]; then . "/opt/ros/crystal/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/crystal/setup.sh" ]; then . "/opt/ros/crystal/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/crystal/setup.sh" ]; then . "/opt/ros/crystal/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-crystal-depth-image-proc//opt/ros/crystal/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/crystal/setup.sh" ]; then . "/opt/ros/crystal/setup.sh"; fi && \
	dh_auto_install
